﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class StageSelect : MonoBehaviour {
	public GameObject child;

	void Start(){
		foreach (string scene in SceneControl.stages) {
			GameObject obj = Instantiate (child, child.transform.parent);
			obj.GetComponent<Text> ().text = scene;
			obj.GetComponent<Button> ().onClick.AddListener (() => {
				SceneControl.I.LoadScene("GameMain",scene);
			});
		}
		child.SetActive (false);
	}

}
