﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class Fade : MonoBehaviour {
	public Image fadeObj;

	public float fadeTime;

	[ContextMenu("FadeIn")]
	public void FadeIn(){
		StartCoroutine (IEFadeIn ());
	}
	private IEnumerator IEFadeIn(){
		Color col = new Color (0, 0, 0, 1);

		float goalTime = Time.time + fadeTime;
		while (goalTime > Time.time) {
			col.a = (goalTime - Time.time) / fadeTime;
			fadeObj.color = col;
			yield return null;
		}
		col.a = 0.0f;
		fadeObj.color = col;
	}

	[ContextMenu("FadeOut")]
	public void FadeOut(){
		StartCoroutine (IEFadeOut ());
	}
	private IEnumerator IEFadeOut(){
		Color col = new Color (0, 0, 0, 0);

		float goalTime = Time.time + fadeTime;
		while (goalTime > Time.time) {
			col.a = 1 - ((goalTime - Time.time) / fadeTime);
			fadeObj.color = col;
			yield return null;
		}
		col.a = 1.0f;
		fadeObj.color = col;
	}

	public void Load(){
		SceneManager.LoadScene ("Main");
	}
}
