﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GestureRecognize : SingletonMonoBehaviourFast<GestureRecognize> {

	public event System.Action<Vector3> OnFlick;

	private Vector3 m_StartTapPos;
	private float m_StartTapTime;
	void Update(){
		if (Input.GetMouseButtonDown (0)) {
			m_StartTapPos = Input.mousePosition;
			m_StartTapTime = Time.time;
		} else if (Input.GetMouseButtonUp (0)) {
			if (Time.time - m_StartTapTime < 0.3f) {
				if (OnFlick != null) {
					OnFlick.Invoke (Input.mousePosition - m_StartTapPos);
				}
			}
		}
	}
}
