﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GoalScript : MonoBehaviour {
	public CameraPathAnimator cameraAnim;
	public GameObject m_Fireworks;
	public PlayerScript m_Player;
	private bool played = false;

	public AudioSource m_Audio;
	void OnTriggerEnter(Collider coll){
		if(!played && coll.CompareTag("Player")){
//			cameraAnim.Play ();
			GetComponent<LineRenderer>().enabled = false;
			played = true;
			StartCoroutine(PlayAnimation());
		}
	}

	public GameObject m_NormalUI;
	public GameObject m_ClearUI;

	private IEnumerator PlayAnimation(){
		m_NormalUI.SetActive (false);
		m_Audio.enabled = true;
		cameraAnim.Play ();
		m_Player.GoToSea ();
		yield return new WaitForSeconds (cameraAnim.animationTime-4.5f);
		m_Fireworks.SetActive (true);
		//yield return new WaitForSeconds (1.0f);
		m_ClearUI.SetActive (true);

		yield return new WaitUntil(()=>Input.GetMouseButtonDown(0));
//		SceneControl.I.GoNextStage ();
		SceneControl.I.LoadScene("GameOver","");
	}
}
