﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class InGameUIManager : MonoBehaviour {
	public Transform m_WhaleGo;
	public RectTransform m_WhaleIcon;

	[SerializeField]
	private float StartZ;
	[SerializeField]
	private float GoalZ;

	[SerializeField]
	private float StartY;
	[SerializeField]
	private float GoalY;

	[SerializeField]private Transform m_SpriteTR;

	void Update(){
		float pos = (m_WhaleGo.position.z - StartZ) / (GoalZ - StartZ);
		Vector2 anchor = new Vector2 (pos, 0.5f);
		m_WhaleIcon.pivot = anchor;
		m_WhaleIcon.anchorMax = anchor;
		m_WhaleIcon.anchorMin = anchor;

		Vector3 sppos = m_SpriteTR.localPosition;
		sppos.y = Mathf.Lerp (StartY,GoalY,pos);
		m_SpriteTR.localPosition = sppos;
	}


	public void GoTitle(){
		SceneControl.I.LoadScene ("Title");
	}
}
