﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using DG.Tweening;

public class TakoScript : MonoBehaviour {
	private Rigidbody _rigidbody;
	private Rigidbody m_Rigidbody{
		get{
			return _rigidbody ?? (_rigidbody = GetComponent<Rigidbody>());
		}
	}
	[Range(0.1f,5)]
	public float Duration;
	[Range(-10,10)]
	public float MoveDeltaX;
	[Range(-10,10)]
	public float MoveDeltaZ;
	void Start(){
		m_Rigidbody.DOMove (new Vector3(this.transform.position.x + MoveDeltaX,this.transform.position.y,this.transform.position.z + MoveDeltaZ),
			Duration).SetLoops (-1, LoopType.Yoyo).SetEase(Ease.Linear);
	}
}
