﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using DG.Tweening;
using UnityEngine.SceneManagement;

public class SunSetTimer : MonoBehaviour {

    public GameObject directionalLight;
    public float time;

    [SerializeField]
    private Vector3 m_TargetEulerAngle;

    void Start()
    {
        DOTween.Init();
        //40,130,740
        //0,210,540
        directionalLight.transform.DORotate(m_TargetEulerAngle, time).OnComplete(Sunset);
    }

    private void Sunset()
    {
        SceneManager.LoadScene("GameOver");
    }
}

